<?php

/*
 * ajax.php
 *
 * @copyright     Copyright 2009-2012 Hamid Reza Samak
 * @link          http://www.limny.org
 * @package       limny
 * @author        Hamid Reza Samak <hamid@limny.org>
 * @license       GNU/GPL License (http://www.gnu.org/licenses/gpl.html)
 */

require('init.php');
require('../incs/form.class.php');

$class['form'] = new Form;

if (@$_GET['a'] != 'default' && @$_GET['a'] != 'features' && !$class['admin']->is_permitted(@$_GET['a']))
{
	exit;
}
	
switch (@$_GET['a'])
{
	case ('default');
		if ($class['form']->validate_referer())
		{
			if ($default = @file_get_contents('http://www.limny.org/default'))
			{
				print $default;
			}
		}
	break;
	
	case ('features');
		if ($class['form']->validate_referer())
		{
			if (isset($_POST['app']) && in_array($_POST['app'], $class['admin']->installed_apps()))
			{
				if (file_exists('../apps/' . $_POST['app'] . '/' . $_POST['app'] . '.php'))
				{
					include('../apps/' . $_POST['app'] . '/' . $_POST['app'] . '.php');
					if (function_exists('features'))
					{
						$class['admin']->load_language($_POST['app']);
						
						$features = features();
						
						if (is_array($features))
						{
							print '<ul class="features">';
							foreach ($features as $key => $value)
							{
								print '<li><a href="' . $value . '">' . $key . '</a></li>';
							}
							print '</ul>';
						}
						else
						{
							print $features;
						}
					}
				}
			}
		}
	break;
	
	case ('blocks');
		if (isset($_POST['e']) && $class['form']->validate_referer())
		{
			$e = explode(',', $_POST['e']);
			$position = end($e);
			$position = explode('_', $position);
			$position = end($position);
			$posi_md5 = md5($position);
			for ($i = 0; $i < count($e) - 1; $i++)
			{
				$widget = explode('_', $e[$i]);
				$db->update('widgets', array('id' => '\'' . ($i + 1). '\'', 'position' => '\'' . $db->escape($posi_md5) . '\''), array('id' => '=\'' . $db->escape($widget[3]) . '\'', 'AND', 'position' => '=\'' . $db->escape($widget[2]) . '\''));
				unset($widget);
			}
			$db->update('widgets', array('position' => '\'' . $db->escape($position) . '\''), array('position' => '=\'' . $db->escape($posi_md5) . '\''));
			
			$result = $db->select('widgets', array('id'), array('name' => '=\'Custom\'', 'AND', 'position' => '=\'none\''));
			if (!$custom = $db->fetch_assoc($result))
			{
				$result = $db->select('widgets', array('id'), array('position' => '=\'none\'', 'ORDER BY', 'id' => 'DESC'));
				if ($num = $db->fetch_assoc($result))
				{
					$num = $num['id'] + 1;
				}
				else
				{
					$num = 1;
				}
				
				$db->insert('widgets', array('id' => $num, 'app' => 'limny', 'name' => 'Custom', 'position' => 'none', 'languages' => 'all', 'roles' => 'all'));
				print $num;
			}
		}
	break;
	
	case ('appearance');
		if (isset($_POST['b']) && $class['form']->validate_referer())
		{
			$theme = $_POST['theme'];
			if (in_array($theme, $class['admin']->themes_list()))
			{
				if ($_POST['b'] == 'install' && !in_array($theme, $class['admin']->installed_themes()))
				{
					if ($class['admin']->theme_is_compatible($theme))
					{
						$db->insert('themes', array('name' => $db->escape($theme)));
						
						if (file_exists('../themes/' . $theme . '/install.php'))
						{
							include('../themes/' . $theme . '/install.php');
							if (function_exists('install'))
							{
								install();
								
								$images_result = $db->select('images', array('id'), array('theme' => '=\'' . $db->escape($theme) . '\''));
								$styles_result = $db->select('styles', array('id'), array('theme' => '=\'' . $db->escape($theme) . '\''));
								$styles = ($db->num_rows($images_result) > 0 || $db->num_rows($styles_result) > 0) ? '<li class="styles"><a href="index.php?p=styles/' . $theme . '">' . STYLES . '</a></li>' : NULL;
							}
						}
						
						echo 'INSTALLED<ul><li class="setasdefault"><a href="#' . $theme . '">' . SET_AS_DEFAULT . '</a></li></ul><ul>' . (isset($styles) ? $styles : NULL) . '<li class="edit"><a href="index.php?p=edit/' . $theme . '">' . EDIT . '</a></li><li class="uninstall"><a href="#' . $theme . '">' . UNINSTALL . '</a></li></ul>';
					}
					else
					{
						echo 'MESSAGE' . INFO_12;
					}
				}
				else if ($_POST['b'] == 'uninstall' && in_array($theme, $class['admin']->installed_themes()))
				{
					if ($class['config']->theme != $theme)
					{
						$db->delete('themes', array('name' => '=\'' . $db->escape($theme) . '\''));
						
						if (file_exists('../themes/' . $theme . '/install.php'))
						{
							include('../themes/' . $theme . '/install.php');
							if (function_exists('uninstall'))
							{
								uninstall();
								$class['admin']->reset_users_theme($theme);
							}
						}
						
						echo 'UNINSTALLED<ul><li class="install"><a href="#' . $theme . '">' . INSTALL . '</a></li><li class="edit"><a href="index.php?p=edit/' . $theme . '">' . EDIT . '</a></li></ul>';
					}
					else
					{
						echo 'MESSAGE' . INFO_11;
					}
				}
				else if ($_POST['b'] == 'setasdefault' && in_array($theme, $class['admin']->installed_themes()) && $class['config']->theme != $theme)
				{
					$default_images = $db->select('images', array('id'), array('theme' => '=\'' . $db->escape($class['config']->theme) . '\''));
					$default_styles = $db->select('styles', array('id'), array('theme' => '=\'' . $db->escape($class['config']->theme) . '\''));
					$default = ($db->num_rows($default_images) > 0 || $db->num_rows($default_styles) > 0) ? '<li class="styles"><a href="#">' . STYLES . '</a></li>' : NULL;
					
					$db->update('config', array('value' => '\'' . $db->escape($theme) . '\''), array('name' => '=\'theme\''));
					
					$images_result = $db->select('images', array('id'), array('theme' => '=\'' . $db->escape($theme) . '\''));
					$styles_result = $db->select('styles', array('id'), array('theme' => '=\'' . $db->escape($theme) . '\''));
					$styles = ($db->num_rows($images_result) > 0 || $db->num_rows($styles_result) > 0) ? '<li class="styles"><a href="index.php?p=styles/' . $theme . '">' . STYLES . '</a></li>' : NULL;
					
					echo 'DONE<ul>' . $styles . '<li class="edit"><a href="index.php?p=edit/' . $theme . '">' . EDIT . '</a></li><li class="uninstall"><a href="#' . $theme . '">' . UNINSTALL . '</a></li></ul>|<ul><li class="setasdefault"><a href="#">' . SET_AS_DEFAULT . '</a></li></ul><ul>' . $default . '<li class="edit"><a href="#">' . EDIT . '</a></li><li class="uninstall"><a href="#">' . UNINSTALL . '</a></li></ul>';
				}
			}
		}
	break;
	
	case ('edit');
		if (isset($_POST['theme']) && isset($_POST['file']) && $class['form']->validate_referer())
		{
			$theme = $_POST['theme'];
			$file = $_POST['file'];
			
			if (in_array($theme, $class['admin']->themes_list()) && file_exists('../themes/' . $theme . '/' . $file))
			{
				$class['file'] = new File;
				
				echo $class['file']->get_contents('../themes/' . $theme . '/' . $file);
			}
		}
	break;
	
	case ('config');
		if (isset($_POST['c']) && $class['form']->validate_referer())
		{
			switch ($_POST['c'])
			{
				case ('app');
					echo APPLICATION . ':<br /><span class="desc">' . INFO_18 . '</span>|<select name="app">';
					
					foreach ($class['admin']->installed_apps() as $app)
					{
						$info = $class['admin']->app_get_info($app);
						$selected = ($app == $class['config']->content_app) ? ' selected="selected"' : NULL;
						
						echo '<option value="' . $app . '"' . $selected . '>' . $info['name'] . '</option>';
					}
					
					echo '</select>';
				break;
				
				case ('query');
					echo QUERY . ':<br /><span class="desc">' . INFO_19 . '</span>|<input name="query" type="text" value="' . ($class['config']->content_query) . '" />';
				break;
				
				case ('code');
					echo CODE . ':<br /><span class="desc">' . INFO_20 . '</span>|<textarea name="code" rows="10" cols="50">' . str_replace(array('&', '<', '>', '"'), array('&amp;', '&lt;', '&gt;', '&quot;'), $class['config']->content_code) . '</textarea>';
				break;
			}
		}
	break;
	
	case ('usersroles');
		if (isset($_POST['b']) && isset($_POST['c']) && isset($_POST['d']) && $class['form']->validate_referer())
		{
			switch ($_POST['c'])
			{
				case ('user');
					if (!empty($_POST['d']))
					{
						if (preg_match("/^([a-z0-9])(([-a-z0-9._])*([a-z0-9]))([a-z0-9])*$/i" , $_POST['d']))
						{
							$result = $db->select('users', array('users'), array('id' => '!=\'' . $db->escape($_POST['b']) . '\'', 'AND', 'user' => '=\'' . $db->escape($_POST['d']) . '\''));
							if (!$user = $db->fetch_assoc($result))
							{
								$db->update('users', array('user' => '\'' . $db->escape($_POST['d']) . '\''), array('id' => '=\'' . $db->escape($_POST['b']) . '\''));
								
								echo '|' . $_POST['d'];
								exit;
							}
							else
							{
								echo '*' . INFO_22;
							}
						}
						else
						{
							echo '*' . INFO_21;
						}
					}
					
					$result = $db->select('users', array('user'), array('id' => '=\'' . $db->escape($_POST['b']) . '\''));
					echo ($user = $db->fetch_assoc($result)) ? '|' . $user['user'] : NULL;
				break;
				
				case ('email');
					if (!empty($_POST['d']))
					{
						if (preg_match('/^([a-z0-9])(([-a-z0-9._])*([a-z0-9]))*\@([a-z0-9])*(\.([a-z0-9])([-a-z0-9_-])([a-z0-9])+)*$/i' , $_POST['d']))
						{
							$result = $db->select('users', array('id'), array('id' => '!=\'' . $db->escape($_POST['b']) . '\'', 'AND', 'email' => '=\'' . $db->escape($_POST['d']) . '\''));
							if (!$user = $db->fetch_assoc($result))
							{
								$db->update('users', array('email' => '\'' . $db->escape($_POST['d']) . '\''), array('id' => '=\'' . $db->escape($_POST['b']) . '\''));
								
								echo '|' . $_POST['d'];
								exit;
							}
							else
							{
								echo '*' . INFO_24;
							}
						}
						else
						{
							echo '*' . INFO_23;
						}
					}
					
					$result = $db->select('users', array('email'), array('id' => '=\'' . $db->escape($_POST['b']) . '\''));
					echo ($user = $db->fetch_assoc($result)) ? '|' . $user['email'] : NULL;
				break;
				
				case ('role');
					if (!empty($_POST['d']))
					{
						$_POST['d'] = str_replace(array('&', '<', '>', '"'), array('&amp;', '&lt;', '&gt;', '&quot;'), $_POST['d']);
						
						$result = $db->select('roles', array('id'), array('id' => '!=\'' . $db->escape($_POST['b']) . '\'', 'AND', 'name' => '=\'' . $db->escape($_POST['d']) . '\''));
						if (!$role = $db->fetch_assoc($result))
						{
							$db->update('roles', array('name' => '\'' . $db->escape($_POST['d']) . '\''), array('id' => '=\'' . $db->escape($_POST['b']) . '\''));
							$users_result = $db->select('users', array('id'), array('role' => '=\'' . $db->escape($_POST['b']) . '\''));
							
							echo '|' . $_POST['d'] . '|' . ($db->num_rows($users_result));
							exit;
						}
						else
						{
							echo '*' . INFO_25;
						}
					}
					
					$result = $db->select('roles', array('name'), array('id' => '=\'' . $db->escape($_POST['b']) . '\''));
					echo ($role = $db->fetch_assoc($result)) ? '|' . $role['name'] : NULL;
				break;
				
				case ('admin');
					if (!empty($_POST['d']))
					{
						$admin = ($_POST['d'] == 'green' && $_POST['b'] != 1) ? 0 : 1;
						$db->update('users', array('admin' => '\'' . $admin . '\''), array('id' => '=\'' . $db->escape($_POST['b']) . '\''));
						
						echo ($admin == 1) ? '<span class="green">' . YES . '</span>' : '<span class="red">' . NO . '</span>';
					}
				break;
				
				case ('ban');
					if (!empty($_POST['d']))
					{
						$ban = ($_POST['d'] == 'red' && $_POST['b'] != 1) ? 1 : 0;
						$db->update('users', array('ban' => '\'' . $ban . '\''), array('id' => '=\'' . $db->escape($_POST['b']) . '\''));
						
						echo ($ban == 1) ? '<span class="green">' . YES . '</span>' : '<span class="red">' . NO . '</span>';
					}
				break;
			}
		}
	break;
}

?>