<?php

/*
 * mysql.class.php
 *
 * @copyright     Copyright 2009-2012 Hamid Reza Samak
 * @link          http://www.limny.org
 * @package       limny
 * @author        Hamid Reza Samak <hamid@limny.org>
 * @license       GNU/GPL License (http://www.gnu.org/licenses/gpl.html)
 */
 
class MySQL
{
	var $connection;
	var $tbl_prfx = '';
	var $classifier = '`';
	
	function connect($hostname, $username, $password)
	{
		$connection = @mysql_connect($hostname, $username, $password, TRUE);
		$this->connection = $connection;
		
		return $connection;
	}
	
	function close()
	{
		return mysql_close($this->connection);
	}
	
	function select_db($database)
	{
		return @mysql_select_db($database, $this->connection);
	}
	
	function query($query)
	{
		return mysql_query($query, $this->connection);
	}
	
	function select($table, $columns, $expression = NULL)
	{
		$query = 'SELECT ';
		
		if (is_array($columns))
		{
			foreach ($columns as $value)
			{
				$query .= '`' . $value . '`,';
			}
			$query = substr($query, 0, strlen($query) - 1);
		}
		else
		{
			$query .= $columns;
		}
		
		$query .= ' FROM `' . $this->tbl_prfx . $table . '`';
		
		if (!empty($expression))
		{
			$query .= $this->parse_expr($expression);
		}
		
		return $this->query($query);
	}
	
	function insert($table, $values)
	{
		$query = 'INSERT INTO `' . $this->tbl_prfx . $table . '` (';
		
		$keys = '';
		$vals = '';
		foreach ($values as $key => $value)
		{
			$keys .= '`' . $key . '`,';
			$vals .= is_null($value) ? 'NULL,' : '\'' . $value . '\',';
		}
		$query .= substr($keys, 0, strlen($keys) - 1) . ') VALUES (' . substr($vals, 0, strlen($vals) - 1) . ')';
		
		return $this->query($query);
	}
	
	function update($table, $values, $expression = NULL)
	{
		$query = 'UPDATE `' . $this->tbl_prfx . $table . '` SET ';
		
		foreach ($values as $key => $value)
		{
			$query .= '`' . $key . '`=';
			$query .= is_null($value) ? 'NULL,' : $value . ',';
		}
		$query = substr($query, 0, strlen($query) - 1);
		
		if (!empty($expression))
		{
			$query .= $this->parse_expr($expression);
		}
		
		return $this->query($query);
	}
	
	function delete($table, $expression = NULL)
	{
		$query = 'DELETE FROM `' . $this->tbl_prfx . $table . '`';
		
		if (!empty($expression))
		{
			$query .= $this->parse_expr($expression);
		}
		
		return $this->query($query);
	}
	
	function create_table($table, $columns, $auto_increment_column = NULL, $additions = NULL)
	{
		$query = 'CREATE TABLE `' . $this->tbl_prfx . $table . '` (';
		
		foreach ($columns as $key => $value)
		{
			$query .= '`' . $key . '` ' . $value . (!empty($auto_increment_column) && $key == $auto_increment_column ? ' AUTO_INCREMENT' : NULL) . ',';
		}
		
		if (empty($auto_increment_column))
		{
			$query = substr($query, 0, strlen($query) - 1);
		}
		else
		{
			$query .= 'PRIMARY KEY (`' . $auto_increment_column . '`)';
		}
		
		$query .= ')' . (isset($additions) ? ' ' . $additions : NULL);
		
		return $this->query($query);
	}
	
	function drop_table($table, $auto_increment_column = NULL)
	{
		$query = 'DROP TABLE `' . $this->tbl_prfx . $table . '`';
		
		return $this->query($query);
	}
	
	function fetch_row($result)
	{
		return mysql_fetch_row($result);
	}
	
	function fetch_assoc($result)
	{
		return mysql_fetch_assoc($result);
	}
	
	function fetch_array($result)
	{
		return mysql_fetch_array($result);
	}
	
	function num_rows($result)
	{
		return mysql_num_rows($result);
	}
	
	function num_fields($result)
	{
		return mysql_num_fields($result);
	}
	
	function parse_expr($expression)
	{
		if (is_array($expression))
		{
			$result = ' WHERE ';
			
			foreach ($expression as $key => $value)
			{
				if (is_numeric($key))
				{
					$result .= $value . ' ';
				}
				else
				{
					$result .= '`' . $key . '`' . $value . ' ';
				}
			}
			
			$result = substr($result, 0, strlen($result) - 1);
		}
		else
		{
			$result = ' ' . $expression;
		}
		
		return $result;
	}
	
	function escape($str, $internal = FALSE)
	{
		if (!get_magic_quotes_gpc() || $internal == TRUE)
		{
			return function_exists('mysql_real_escape_string') ? mysql_real_escape_string($str, $this->connection) : addslashes($str);
		}
		
		return $str;
	}
}

?>